import memoize from 'memoize-one';
import React, { Component } from 'react';

class MemoizeExample extends Component {
    constructor() {
        super();

        this.state = { buttonClicks: 0, tally: 0 };

        this.memoizedAdd = memoize(() => this.add());
    }

    // Called the memoizeAdd here to make the tally always equal one more than the button counts
    // Here, the use is very minimal however is just an example with the code in the same place as my project where the spot is appropriate
    componentDidMount() {
        const { buttonClicks } = this.state;

        // You can change the use of memoizedAdd to memoizedAdd(1) and it will still infinite loop in tests
        this.memoizedAdd(buttonClicks);
    }

    componentDidUpdate() {
        const { buttonClicks } = this.state;

        // You can change the use of memoizedAdd to memoizedAdd(1) and it will still infinite loop in tests
        this.memoizedAdd(buttonClicks);
    }

    add() {
        const { tally } = this.state;

        this.setState({ tally: tally + 1 });
    }

    render () {
        const { buttonClicks, tally } = this.state;

        return ( 
            <div>
                <button onClick={() => this.setState({ buttonClicks: buttonClicks + 1 })}>
                    Click Me
                </button>
                <br />
                Tally: {tally}
                <br />
                Button Clicks: {buttonClicks}
            </div>
        );
    }
}

export default MemoizeExample;
